import sys
import random
import os.path as osp
import shutil

from torch_geometric.datasets import TUDataset


def test_bzr():
    root = osp.join('/', 'tmp', str(random.randrange(sys.maxsize)))
    dataset = TUDataset(root, 'BZR')

    assert len(dataset) == 405
    assert dataset.num_features == 53
    assert dataset.num_node_labels == 53
    assert dataset.num_node_attributes == 0
    assert dataset.num_classes == 2
    assert dataset.__repr__() == 'BZR(405)'
    assert len(dataset[0]) == 3

    dataset = TUDataset(root, 'BZR', use_node_attr=True)
    assert dataset.num_features == 56
    assert dataset.num_node_labels == 53
    assert dataset.num_node_attributes == 3

    shutil.rmtree(root)
